Index: trunk/tools/bootloader_tsar/boot_fat32.c
===================================================================
--- trunk/tools/bootloader_tsar/boot_fat32.c	(revision 1)
+++ trunk/tools/bootloader_tsar/boot_fat32.c	(revision 6)
@@ -148,5 +148,5 @@
 {
 #if DEBUG_BOOT_FAT32    
-    boot_printf("\n[BOOT] %s: Enters at cycle %d\n",
+    boot_printf("\n[BOOT INFO] %s enters at cycle %d\n",
                 __FUNCTION__ , boot_get_proctime() );
 #endif
@@ -163,5 +163,5 @@
 
 #if DEBUG_BOOT_FAT32    
-    boot_printf("\n[BOOT] %s: FSI Sector loaded at cycle %d\n",
+    boot_printf("\n[BOOT INFO] %s : FSI Sector loaded at cycle %d\n",
                 __FUNCTION__ , boot_get_proctime() );
 #endif
@@ -197,5 +197,5 @@
 
 #if DEBUG_BOOT_FAT32    
-    boot_printf("\n[BOOT] %s: free_clusters_nr = %x / free_cluster_hint = %x\n",
+    boot_printf("\n[BOOT INFO] %s : free_clusters_nr = %x / free_cluster_hint = %x\n",
                 __FUNCTION__ , boot_fat.free_clusters_nr , boot_fat.free_cluster_hint );
 #endif
@@ -430,5 +430,5 @@
 
 #if DEBUG_BOOT_FAT32    
-    boot_printf("\n[BOOT] %s: returns <%s> from <%s> at cycle %d\n",
+    boot_printf("\n[BOOT INFO] %s : returns <%s> from <%s> at cycle %d\n",
                 __FUNCTION__ , path_component , pathname , boot_get_proctime() );
 #endif
@@ -592,5 +592,5 @@
 
 #if DEBUG_BOOT_FAT32    
-    boot_printf("\n[BOOT] %s: Enters for <%s> file at cycle %d\n",
+    boot_printf("\n[BOOT INFO] %s enters for <%s> file at cycle %d\n",
                 __FUNCTION__ , pathname, boot_get_proctime());
 #endif
@@ -615,7 +615,4 @@
         while ( found == 0 )
         {
-
-boot_printf("\n!!! enter second while for <%s> path_comp\n", path_comp );
-
             cluster_lba = cluster_to_lba( parent_cluster );
             
@@ -646,7 +643,4 @@
                 if (ord == LAST_ENTRY)             // no more entry in this directory
                 {
-
-boot_printf("\n@@@ for <%s> component / offset = %d : last entry\n", path_comp , offset );
-
                     found = 2;
                 }
@@ -654,7 +648,4 @@
                 else if (ord == FREE_ENTRY)        // unused, check the next entry
                 {
-
-boot_printf("\n@@@ for <%s> component / offset = %d : free entry\n", path_comp , offset );
-
                     continue;
                 }
@@ -672,7 +663,4 @@
                     get_name_from_long(entry, buffer_lfn);
 
-boot_printf("\n@@@ for <%s> component / offset = %d : LFN entry = %s\n", 
-            path_comp , offset , buffer_lfn );
-
                     // Append this portion of the name to the full name buffer
                     boot_strcpy(name + 13 * (lfn_seq_order-1) , buffer_lfn);
@@ -685,7 +673,4 @@
                 {
                     if (lfn_seq_elem_nr == 0) get_name_from_short(entry, name);
-
-boot_printf("\n@@@ for <%s> component / offset = %d : SFN entry = %s\n", 
-            path_comp , offset , name );
 
                     // check if the full name is what we are looking for.
@@ -725,6 +710,4 @@
         } // end second while for one component in pathname
         
-boot_printf("\n### exit hwile fpr component <%s>\n", path_comp );
-
         // Check the result of this path component search.
         if (found == 2)
@@ -755,7 +738,7 @@
 
 #if DEBUG_BOOT_FAT32    
-    boot_printf("\n[BOOT] fat_file_search(): "
-                "<%s> file of size %x found at cluster %x at cycle %d\n",
-                pathname, *file_size, *first_cluster, boot_get_proctime());
+    boot_printf("\n[BOOT INFO] %s : <%s> file found at cycle %d\n"
+                "    fat_cluster = %x / size = %x\n",
+                __FUNCTION__ , pathname , boot_get_proctime() , *first_cluster , *file_size );
 #endif
 
@@ -771,7 +754,4 @@
 int boot_fat32_init()
 {
-
-boot_printf("@@@ BEFORE_VALUE = %x\n", FAT_MAGIC_VALUE);
-
     // FAT32 initialization should be done only once
     if (boot_fat.initialized == FAT_MAGIC_VALUE)
@@ -783,5 +763,5 @@
 
 #if DEBUG_BOOT_FAT32    
-boot_printf("\n[BOOT] %s: Enters at cycle %d\n",
+boot_printf("\n[BOOT INFO] %s: Enters at cycle %d\n",
             __FUNCTION__ , boot_get_proctime() );
 #endif
@@ -799,9 +779,6 @@
 
 #if DEBUG_BOOT_FAT32    
-boot_printf("\n[BOOT] %s: Boot Sector loaded at cycle %d\n",
+boot_printf("\n[BOOT INFO] %s: Boot Sector loaded at cycle %d\n",
             __FUNCTION__ , boot_get_proctime() );
-// unsigned char * data = boot_fat.block_buffer;
-// uint32_t   byte;
-// for( byte = 0 ; byte < 16 ; byte++ ) boot_printf("%d : %x\n", byte , data[byte] );
 #endif
 
@@ -865,8 +842,4 @@
     boot_fat.initialized    = FAT_MAGIC_VALUE;
 
-boot_printf("@@@ AFTER_VALUE = %x\n", FAT_MAGIC_VALUE);
-
-fat32_desc_display();
-    
     // Set information from FS Information Sector
     if (set_fsi()) return -1;
@@ -878,6 +851,6 @@
 #if DEBUG_BOOT_FAT32    
     fat32_desc_display();
-    boot_printf("\n[BOOT] boot_fat32_init(): FAT32 File System initialized at cycle %d\n",
-                boot_get_proctime());
+    boot_printf("\n[BOOT INFO] %s : FAT32 File System initialized at cycle %d\n",
+                __FUNCTION__ , boot_get_proctime() );
 #endif
 
@@ -907,5 +880,5 @@
 
 #if DEBUG_BOOT_FAT32    
-    boot_printf("\n[BOOT] %s: Enters for file <%s> at cycle %d\n",
+    boot_printf("\n[BOOT INFO] %s enters for file <%s> at cycle %d\n",
                 __FUNCTION__ , pathname, boot_get_proctime() );
 #endif
@@ -973,7 +946,7 @@
 
 #if DEBUG_BOOT_FAT32    
-    boot_printf("\n[BOOT] boot_fat32_load(): "
-                "File <%s> of size %x loaded at address %x at cycle %d\n",
-                pathname, size, buff_addr, boot_get_proctime());
+    boot_printf("\n[BOOT INFO] %s : file <%s> loaded at cycle %d\n"
+                "    address = %x , size = %x\n",
+                __FUNCTION__ , pathname , boot_get_proctime() , buff_addr , size );
 #endif
 