Index: trunk/almos_config.h
===================================================================
--- trunk/almos_config.h	(revision 1)
+++ trunk/almos_config.h	(revision 12)
@@ -30,4 +30,35 @@
 
 ////////////////////////////////////////////////////////////////////////////////////////////
+//          KERNEL DEBUG 
+////////////////////////////////////////////////////////////////////////////////////////////
+
+#define CONFIG_CONTEXT_DEBUG          0
+#define CONFIG_CORE_DEBUG             0
+#define CONFIG_DMA_DEBUG              0
+#define CONFIG_DQDT_DEBUG             0
+#define CONFIG_ELF_DEBUG              0
+#define CONFIG_EXEC_DEBUG             0
+#define CONFIG_FBF_DEBUG              0
+#define CONFIG_FORK_DEBUG             0
+#define CONFIG_ICU_DEBUG              0
+#define CONFIG_IOC_DEBUG              0
+#define CONFIG_KCM_DEBUG              0
+#define CONFIG_KHM_DEBUG              0
+#define CONFIG_KINIT_DEBUG            0
+#define CONFIG_KMEM_DEBUG             0
+#define CONFIG_MMC_DEBUG              0
+#define CONFIG_MAPPER_DEBUG           0 
+#define CONFIG_NIC_DEBUG              0
+#define CONFIG_PIC_DEBUG              0
+#define CONFIG_PPM_DEBUG              0
+#define CONFIG_PROCESS_DEBUG          0
+#define CONFIG_RPC_DEBUG              0
+#define CONFIG_SCHED_DEBUG            0
+#define CONFIG_THREAD_DEBUG           0
+#define CONFIG_TXT_DEBUG              0
+#define CONFIG_VFS_DEBUG              0
+#define CONFIG_VMM_DEBUG              0
+
+////////////////////////////////////////////////////////////////////////////////////////////
 //        HARDWARE CONFIGURATION     
 ////////////////////////////////////////////////////////////////////////////////////////////
@@ -36,6 +67,7 @@
 #define CONFIG_CYCLES_PER_MS                1000000    // about 1 Ghz             
 #define CONFIG_MAX_CLUSTER                  256        // max number of clusters
-#define CONFIG_MAX_CORES_PER_CLUSTER        4          // max number of cores per cluster
-#define CONFIG_MAX_DEVICES_PER_CLUSTER      32         // max number of periphs per cluster 
+#define CONFIG_MAX_LOCAL_CORES              4          // max number of cores per cluster
+#define CONFIG_MAX_INT_DEV                  4          // max number of internal peripherals
+#define CONFIG_MAX_EXT_DEV                  8          // max number of external peripherals
 #define CONFIG_MAX_HWIS_PER_ICU             32         // max number of HWI per ICU
 #define CONFIG_MAX_PTIS_PER_ICU             32         // max number of PTI per ICU
@@ -46,7 +78,10 @@
 #define CONFIG_CACHE_LINE_SIZE              64         // number of bytes in cache line
 
-#define CONFIG_MAX_TXT_CHANNELS             32         // max number of TXT device channels
-#define CONFIG_MAX_NIC_CHANNELS             32         // max number of NIC device channels
-#define CONFIG_MAX_CMA_CHANNELS             32         // max number of CMA device channels
+#define CONFIG_MAX_IOC_CHANNELS             1          // max number of IOC device channels
+#define CONFIG_MAX_FBF_CHANNELS             1          // max number of FBF device channels
+#define CONFIG_MAX_TXT_CHANNELS             16         // max number of TXT device channels
+#define CONFIG_MAX_DMA_CHANNELS             8          // max number of TXT device channels
+#define CONFIG_MAX_NIC_CHANNELS             8          // max number of NIC device channels
+
 #define CONFIG_MAX_CLUSTERS                 256        // max number of clusters
 
@@ -129,6 +164,6 @@
 ////////////////////////////////////////////////////////////////////////////////////////////
 
-#define CONFIG_THREAD_MAX_PER_CLUSTER      16     // max number of user threads per cluster
-#define CONFIG_THREAD_PAGE_ORDER           1      // ln( number of pages for thread_t )
+#define CONFIG_THREAD_MAX_PER_CLUSTER       16     // max number of user threads per cluster
+#define CONFIG_THREAD_PAGE_ORDER            1      // ln( number of pages for thread_t )
 
 ////////////////////////////////////////////////////////////////////////////////////////////
@@ -144,6 +179,6 @@
 ////////////////////////////////////////////////////////////////////////////////////////////
 
-#define CONFIG_RPC_PENDING_MAX              8     // max requests handled by one server 
-#define CONFIG_RPC_THREADS_MAX              8     // max number of RPC threads per core
+#define CONFIG_RPC_PENDING_MAX              8      // max requests handled by one server 
+#define CONFIG_RPC_THREADS_MAX              8      // max number of RPC threads per core
 
 ////////////////////////////////////////////////////////////////////////////////////////////
@@ -151,7 +186,7 @@
 ////////////////////////////////////////////////////////////////////////////////////////////
 
-#define CONFIG_DEV_STDIN           "/dev/tty2"
-#define CONFIG_DEV_STDOUT          "/dev/tty2"
-#define CONFIG_DEV_STDERR          "/dev/tty3"
+#define CONFIG_DEV_STDIN                    "/dev/tty2"
+#define CONFIG_DEV_STDOUT                   "/dev/tty2"
+#define CONFIG_DEV_STDERR                   "/dev/tty3"
 
 ////////////////////////////////////////////////////////////////////////////////////////////
@@ -159,7 +194,7 @@
 ////////////////////////////////////////////////////////////////////////////////////////////
 
-#define CONFIG_MAPPER_MAX_FRAGMENTS        10    // max number of fragments moved 
-#define CONFIG_MAPPER_MIN             CONFIG_VFS_INODE_MIN
-#define CONFIG_MAPPER_MAX             CONFIG_VFS_INODE_MAX
+#define CONFIG_MAPPER_MAX_FRAGMENTS        10      // max number of fragments moved 
+#define CONFIG_MAPPER_MIN                  CONFIG_VFS_INODE_MIN
+#define CONFIG_MAPPER_MAX                  CONFIG_VFS_INODE_MAX
 
 ////////////////////////////////////////////////////////////////////////////////////////////
@@ -194,10 +229,10 @@
 #define CONFIG_PPM_HEAP_ORDER         10           // ln(number of heap pages per cluster)
 
-////////////////////////////////////////////////////////////////////////////////////////////
-//          KERNEL DEBUG 
-////////////////////////////////////////////////////////////////////////////////////////////
-
-#define CONFIG_DMSG_LEVEL                DMSG_DEBUG
-#define CONFIG_XICU_USR_ACCESS           no
+#define CONFIG_KCM_BLOCKS_MAX         CONFIG_PPM_PAGE_SIZE / CONFIG_CACHE_LINE_SIZE
+
+////////////////////////////////////////////////////////////////////////////////////////////
+//     INSTRUMENTATION  ... probably deprecated ...        
+////////////////////////////////////////////////////////////////////////////////////////////
+
 #define CONFIG_SPINLOCK_CHECK            no
 #define CONFIG_SPINLOCK_TIMEOUT          100
@@ -222,17 +257,9 @@
 #define CONFIG_SHOW_EPC_CORE0            no
 #define CONFIG_CORE_TRACE                no
-#define CONFIG_DQDT_DEBUG                no
 #define CONFIG_KFIFO_DEBUG               no
-#define CONFIG_KHM_DEBUG                 no
-#define CONFIG_KCM_DEBUG                 no
-#define CONFIG_KMEM_DEBUG                no
-#define CONFIG_MAPPER_DEBUG              no
 #define CONFIG_SHOW_KMEM_INIT            no
 #define CONFIG_MEM_CHECK                 no
 #define CONFIG_THREAD_TIME_STAT          yes
 #define CONFIG_SCHED_RR_CHECK            no
-#define CONFIG_FORK_DEBUG                no//yes
-#define CONFIG_VMM_DEBUG                 no
-#define CONFIG_ELF_DEBUG                 no
 #define CONFIG_VFAT_PGWRITE_ENABLE       no
 #define CONFIG_VFAT_DEBUG                no
@@ -240,5 +267,4 @@
 #define CONFIG_EXT2_DEBUG                no
 #define CONFIG_METAFS_DEBUG              no
-#define CONFIG_VFS_DEBUG                 no
 #define CONFIG_VFS_INODE_LOCAL           yes
 #define CONFIG_DEVFS_DEBUG               no
@@ -247,15 +273,4 @@
 #define CONFIG_BC_DEBUG                  no
 #define CONFIG_BC_INSTRUMENT             no
-#define CONFIG_LOCKS_DEBUG               no
-#define CONFIG_SCHED_DEBUG               no
-#define CONFIG_VERBOSE_LOCK              no
-#define CONFIG_PID_DEBUG                 no//yes
-#define CONFIG_HTBL_DEBUG                no
-#define CONFIG_SHOW_RPC_MSG              no
-#define CONFIG_EXEC_DEBUG                no
-#define CONFIG_USE_RPC_TEST              yes
-#define CONFIG_SHOW_ALL_BOOT_MSG         no//yes
-#define CONFIG_ALMOS_LIST_DEBUG		     no
-////////////////////////////////////////////////////////////////////////////////////////////
 
 ////////////////////////////////////////////////////////////////////////////////////////////