Index: trunk/kernel/kern/kernel_init.c
===================================================================
--- trunk/kernel/kern/kernel_init.c	(revision 14)
+++ trunk/kernel/kern/kernel_init.c	(revision 19)
@@ -82,9 +82,9 @@
 // This variable defines the local cluster manager 
 __attribute__((section(".kdata")))
-cluster_t            cluster_manager                         CONFIG_CACHE_LINE_ALIGNED; 
+cluster_t            cluster_manager                         CONFIG_CACHE_LINE_ALIGNED;
 
 // This variables define the kernel process0 descriptor
 __attribute__((section(".kdata")))
-process_t            process_zero                            CONFIG_CACHE_LINE_ALIGNED;            
+process_t            process_zero                            CONFIG_CACHE_LINE_ALIGNED;
 
 // This variable defines extended pointers on the distributed chdevs
@@ -197,5 +197,5 @@
                 {
                     cxy_t  cxy = (x<<info->y_width) + y;
-                    hal_remote_swd( XPTR( cxy , &chdev_dir.txt[0] ) , 
+                    hal_remote_swd( XPTR( cxy , &chdev_dir.txt[0] ) ,
                                     XPTR( local_cxy , &txt0_chdev ) );
                 }
@@ -204,5 +204,5 @@
 		    kinit_dmsg("\n[INFO] %s : core[%x][0] created TXT0 chdev"
                        " / paddr = %l at cycle %d\n",
-                       __FUNCTION__ , local_cxy , chdev_func_str( func ), 
+                       __FUNCTION__ , local_cxy , chdev_func_str( func ),
                        XPTR(local_cxy , &txt0_chdev) , hal_time_stamp() );
         }
@@ -257,5 +257,5 @@
     // make ICU specific initialisation 
     // TODO remove these three parameters
-    dev_icu_init( chdev_ptr , dev->param0 , dev->param1 , dev->param2 );     
+    dev_icu_init( chdev_ptr , dev->param0 , dev->param1 , dev->param2 );
 
     // initialize the ICU field in the chdev_dir[x][y] structures
@@ -532,5 +532,5 @@
                 }  // end if match
 
-                // increment chdev global index (matching or not)            
+                // increment chdev global index (matching or not)
                 chdev_gid++;
 
@@ -608,5 +608,5 @@
 	uint32_t   i;
     gid_t      global_id;
-    
+
     // get global identifier from hardware register
     global_id = hal_get_gid(); 
@@ -624,12 +624,12 @@
     }
     return EINVAL;
-}                      
+}
 
 ///////////////////////////////////////////////////////////////////////////////////////////
 // This function is the entry point for the kernel initialisation.
-// It is executed by all cores in all clusters, but only core[0], called CP0,   
+// It is executed by all cores in all clusters, but only core[0], called CP0,
 // initializes the shared resources such as the cluster manager, or the local peripherals.
-// To comply with the multi-kernels paradigm, it access only local cluster memory, using
-// only informations contained in the local boot_info_t structure, set by the bootloader.
+// To comply with the multi-kernels paradigm, it accesses only local cluster memory, using
+// only information contained in the local boot_info_t structure, set by the bootloader.
 ///////////////////////////////////////////////////////////////////////////////////////////
 // @ info    : pointer on the local boot-info structure.
@@ -681,5 +681,5 @@
     }
 
-    // CP0 initialize local cluster manager (cores and memory allocators)
+    // CP0 initializes the local cluster manager (cores and memory allocators)
     if( core_lid == 0 )
     {
@@ -713,8 +713,8 @@
   	core    = &cluster->core_tbl[core_lid];
 
-    // CP0 initialize process_zero descriptor
+    // CP0 initializes the process_zero descriptor
     if( core_lid == 0 ) process_zero_init( info );
 
-    // CP0 allocate and initialise internal peripheral chdev descriptors.
+    // CP0 allocates and initialises the internal peripheral chdev descriptors.
     // Each CP0[cxy] scan the set of its internal (private) peripherals,
     // and allocate memory for the corresponding chdev descriptors.